//---------------------------------------------------------------------------
//
// "mml2mid.dll" 경åѡ "MML2MIDwrap"
//
//      Programed by Sato.S (ȡ)
//
//  2002.10.15  Ver. 1.0.0    ɬפ˶Ʋ Phase 7.4.0
//
//---------------------------------------------------------------------------
#ifndef ENGINE_H
#define ENGINE_H
//---------------------------------------------------------------------------
// ⥸塼ΥСֹϤ˽
#define SAORI_NAME		"MML2MIDwrap"
#define SAORI_AUTHOR	"Sato"	// (ѿ)
#define SAORI_MAJOR		"1"		// ᥸㡼ֹ(ԥꥪ̵)
#define SAORI_MINOR		"0"		// ޥʡֹ(ԥꥪ̵)
#define SAORI_SUBMINOR	"0"		// ˥ޥʡ(ԥꥪ̵)
//---------------------------------------------------------------------------
#include <windows.h>
//---------------------------------------------------------------------------
#include "config.h"
//---------------------------------------------------------------------------
#include <string>
#include <vector>
#include <map>
#include <fstream>
using namespace std;
//---------------------------------------------------------------------------
#include "misc/phttp.h"
#include "misc/mmap.h"
//---------------------------------------------------------------------------
#define SAORIVER	"1.0"
//---------------------------------------------------------------------------
#define SENDER_SYSTEM	0
#define SENDER_LOCAL	1
#define SENDER_UNKNOWN	2
#define SENDER_EXTERNAL	3
//---------------------------------------------------------------------------
class TNS_KawariANI {
private:
public:

	// ¸ߤѥ
	string DataPath;

	// mml2midɤϥɥ
	HINSTANCE h;
	DWORD (WINAPI *Compile)(LPSTR , LPSTR , DWORD , DWORD , LPSTR , DWORD);
	char *pMsg;

	// ƥ٥
	class TSecurityLevel {
	private:
		unsigned int Level;
	public:
		// ƥ٥ꤹ
		// 3 : LOCALĤ
		// 2 : LOCAL, UNKNOWNĤ
		// 1 : (ͽ,Ȥꤢ2Ʊ)
		// 0 : LOCAL, UNKNOWN, EXTERNALĤ
		bool Set(unsigned int lv)
		{
			Level=(lv<=3)?lv:Level;
			return(Level==lv);
		}

		unsigned int Get(void)
		{
			return(Level);
		}

		// SenderĤƤ뤫ɤå
		bool Check(const unsigned int path)
		{
			switch(Level) {
//			case 4: return(path==SENDER_SYSTEM);
			case 3: return(path==SENDER_LOCAL);
			case 2: return(path<=SENDER_UNKNOWN);
			case 1: return(path<=SENDER_UNKNOWN);
			case 0: return(path<=SENDER_EXTERNAL);
			default: return(path<=SENDER_UNKNOWN);
			}
		}

		TSecurityLevel(unsigned int lv)
		{
			Set(lv);
		}
	} SecurityLevel;


	// ꥯȤ˱ʸ
	unsigned int Parse(TMMap<string,string>& request,map<string,string> &response);

public:

	TNS_KawariANI(void);

	~TNS_KawariANI();

	// SAORI/1.0 API

	// DLLɻ˸ƤФ
	// const string& datapath : DLLΥǥ쥯ȥѥ
	//  bool : true
	bool Load(const string& datapath);

	// DLLɻ˸ƤФ
	//  bool : true
	bool Unload(void);

	// ꥯ
	// const string& type : ꥯȤμ
	// const TMMap<string,string>& request : ꥯȥإå
	//  string : 쥹ݥ󥹥ǡ
	string Request(const string& type,TMMap<string,string>& request);

};
//---------------------------------------------------------------------------
// 饤 (modified BSD(FreeBSD) style license)

#define SAORI_CORE_LICENSE \
"Copyright (C) 2001, 2002 Sato\n" \
"All rights reserved.\n" \
"\n" \
"Redistribution and use in source and binary forms, with or without \n" \
"modification, are permitted provided that the following conditions are \n" \
"met: \n" \
"\n" \
"1. Redistributions of source code must retain the above copyright \n" \
"   notice, this list of conditions and the following disclaimer \n" \
"   as the first lines of this file unmodified." \
"\n" \
"2. Redistributions in  binary form must reproduce the above copyright \n" \
"   notice, this list of conditions and the following disclaimer in the \n" \
"   documentation and/or other materials provided with the distribution. \n" \
"\n" \
"THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR \n" \
"IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED \n" \
"WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE \n" \
"DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, \n" \
"INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES \n" \
"(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR \n" \
"SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) \n" \
"HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, \n" \
"STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN \n" \
"ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE \n" \
"POSSIBILITY OF SUCH DAMAGE.\n" \
"\n" \
"License of MT19937 library is following.\n" \
"Redistribution and use in source and binary forms, with or without\n" \
"modification, are permitted provided that the following conditions\n" \
"are met:\n" \
"\n" \
"  1. Redistributions of source code must retain the above copyright\n" \
"     notice, this list of conditions and the following disclaimer.\n" \
"\n" \
"  2. Redistributions in binary form must reproduce the above copyright\n" \
"     notice, this list of conditions and the following disclaimer in the\n" \
"     documentation and/or other materials provided with the distribution.\n" \
"\n" \
"  3. The names of its contributors may not be used to endorse or promote \n" \
"     products derived from this software without specific prior written \n" \
"     permission.\n" \
"\n" \
"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n" \
"\"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\n" \
"LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\n" \
"A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR\n" \
"CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,\n" \
"EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,\n" \
"PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR\n" \
"PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF\n" \
"LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING\n" \
"NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n" \
"SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n"
#endif
